﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

//protected - защищенное поле, с правами доступа для классов, которые будут наследоваться.
//Без него не сможем в другом классе, который наследуется, обратиться к закрытым переменным.
//sealed - запрещается наследовать от класса (пишется перед классом sealed class Name).
//наследование конструкторов: конструкторы срабатывают в порядке наследования от родителя (BaseClass - MyClass)
namespace ConsoleApp3
{
    internal class BaseClass //базовый класс
    {
        /*public int number;
        public string name;*/

        protected int number;
        protected string name;

        /*int number;
        string name;*/

        /*public void getData(int number, string name)
        {
            this.number = number;
            this.name = name;
        }*/

        public BaseClass(int number, string name)
        {
            this.number = number;
            this.name = name;
        }

        public BaseClass(int number)
        {
            this.number = number;
            this.name = "Привет";
        }

        public virtual void show()
        {
            Console.WriteLine("Числовое поле: " + number);
            Console.WriteLine("Текстовое поле " + name);
        }

        public void showShow()
        {
            show();
        }
    }

    //MyClass имеет свойства BaseClass, но не наоборот (в этом случае эквивалентность не работает)
    //
    class MyClass : BaseClass 
    {
        //конструктор в классе, который наследуется от другого срабатывает после того, как сработает конструктор
        //класса, от которого наследуется. То есть необходимо обязательно из этого конструктора передать значения
        //которые передаются в конструкторе базового класса. Это делается с помощью base: ();
        public MyClass(char symbol,int n) : base (n)
        {
            this.symbol = symbol;
        }

        //protected char symbol = 'A';
        char symbol;

        override public void show()
        {
            base.show();
            Console.WriteLine("Я в MyClass");
        }

        //new - мы действительно хотим поменять функцию
        /*new public void show() 
        {
            Console.WriteLine("Числовое поле: " + number);
            Console.WriteLine("Текстовое поле: " + name);
            Console.WriteLine("символьное поле: " + symbol);
        }*/

        /*new public void show()
        {
           base.show();
           Console.WriteLine("символьное поле: " + symbol);
        }*/
    }

    class NewMyClass : MyClass
    {
        public NewMyClass(char symbol, int n) : base(symbol, n)
        {

        }

        new public void show()
        {
            Console.WriteLine("Я в NewMyClass");
        }

        /*new public void show()
        {
            base.show();
            Console.WriteLine("Что-нибудь");
        }*/
    }

    /*class NewMyClass: MyClass
    {
        public bool boolean;

        public void concatenate1()
        {
            Console.WriteLine("Числовое поле: " + number);
            Console.WriteLine("Текстовое поле: " + name);
            Console.WriteLine("Символьное поле: " + symbol);
            Console.WriteLine("Логическое поле: " + boolean);
        }
    }*/
}
